"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const validate_1 = require("../validate");
const extensions_1 = require("../extensions");
const validators_1 = require("../validators");
class Test extends Error {
    constructor() {
        super();
        /**
         *
         */
        this.output = `
${chalk_1.default.bold('TypeScript Validate')} ${chalk_1.default.red('Error')}
`;
    }
}
exports.Test = Test;
class ValidationError extends Error {
}
exports.ValidationError = ValidationError;
class ValidatorError extends ValidationError {
    constructor(validator, field, value, err) {
        super();
        this.validator = validator;
        this.field = field;
        this.value = value;
        this.err = err;
        this.message = this.reason;
    }
    get reason() {
        let response = `in validator [${this.validator}] on field "${this.field}".\n`;
        if (this.err instanceof ValidationError) {
            response += this.err.reason;
        }
        else {
            response += this.err.message;
        }
        return response;
    }
}
exports.ValidatorError = ValidatorError;
let b = validate_1.validate({
    id: validators_1.Primitive(String)
}, {
    id: null
});
let a = validate_1.validate({
    test: {
        world: [
            {
                id: extensions_1.ID(),
                name: validators_1.Optional(validators_1.Primitive(String)),
                children: [validators_1.Any([
                        validators_1.Primitive(String),
                        extensions_1.ID(),
                        {
                            id: 1,
                        }
                    ])]
            }
        ]
    }
}, {
    test: {
        world: [
            {
                id: 1,
                name: undefined,
                children: [
                    '1',
                    '4',
                    {
                        id: 1,
                        name: 'Jeremy'
                    },
                ]
            }
        ]
    }
});
//# sourceMappingURL=index.js.map